package main

import (
	"github.com/raspi/heksa/pkg/color"
)

const (
	//availFlags = "-+# 0"
	esc   = "\033["
	clear = esc + "0m"

	LineEven = esc + "48;5;16m"
	LineOdd  = esc + "48;5;235m"
)

var defaultColor = color.AnsiColor{Color: color.ColorGrey93_eeeeee}
var defaultLineColor = color.AnsiColor{Color: color.ColorCyan1_00ffff}
var defaultSpaceColor = color.AnsiColor{Color: color.ColorMagenta1_ff00ff}

// 0x00 0xFF
var defaultNULLEOFColor = color.AnsiColor{Color: color.ColorRed3_af0000}

var defaultPrintableASCIIColor = color.AnsiColor{Color: color.ColorDeepSkyBlue2_00afd7}

// 0-9
var defaultPrintableASCIINumberColor = color.AnsiColor{Color: color.ColorSteelBlue_5f87af}

// a-z
var defaultPrintableASCIILowerAlphaColor = color.AnsiColor{Color: color.ColorSteelBlue3_5f87d7}

// A-Z
var defaultPrintableASCIIUpperAlphaColor = color.AnsiColor{Color: color.ColorCornflowerBlue_5f87ff}

var defaultUpperBytesColor = color.AnsiColor{Color: color.ColorYellow_ffff00}

// Default colors for bytes 0-255
var defaultCharacterColors = [256]color.AnsiColor{
	0:   defaultNULLEOFColor, // null
	1:   defaultColor,
	2:   defaultColor,
	3:   defaultColor,
	4:   defaultColor,
	5:   defaultColor,
	6:   defaultColor,
	7:   defaultColor,
	8:   defaultColor,
	9:   defaultSpaceColor, // tab
	10:  defaultLineColor,  // \n
	11:  defaultColor,
	12:  defaultColor,
	13:  defaultLineColor, // \r
	14:  defaultColor,
	15:  defaultColor,
	16:  defaultColor,
	17:  defaultColor,
	18:  defaultColor,
	19:  defaultColor,
	20:  defaultColor,
	21:  defaultColor,
	22:  defaultColor,
	23:  defaultColor,
	24:  defaultColor,
	25:  defaultColor,
	26:  defaultColor,
	27:  defaultColor,
	28:  defaultColor,
	29:  defaultColor,
	30:  defaultColor,
	31:  defaultColor,
	32:  defaultSpaceColor, // space
	33:  defaultPrintableASCIIColor,
	34:  defaultPrintableASCIIColor,
	35:  defaultPrintableASCIIColor,
	36:  defaultPrintableASCIIColor,
	37:  defaultPrintableASCIIColor,
	38:  defaultPrintableASCIIColor,
	39:  defaultPrintableASCIIColor,
	40:  defaultPrintableASCIIColor,
	41:  defaultPrintableASCIIColor,
	42:  defaultPrintableASCIIColor,
	43:  defaultPrintableASCIIColor,
	44:  defaultPrintableASCIIColor,
	45:  defaultPrintableASCIIColor,
	46:  defaultPrintableASCIIColor,
	47:  defaultPrintableASCIIColor,
	48:  defaultPrintableASCIINumberColor, // 0
	49:  defaultPrintableASCIINumberColor,
	50:  defaultPrintableASCIINumberColor,
	51:  defaultPrintableASCIINumberColor,
	52:  defaultPrintableASCIINumberColor,
	53:  defaultPrintableASCIINumberColor,
	54:  defaultPrintableASCIINumberColor,
	55:  defaultPrintableASCIINumberColor,
	56:  defaultPrintableASCIINumberColor,
	57:  defaultPrintableASCIINumberColor, // 9
	58:  defaultPrintableASCIIColor,
	59:  defaultPrintableASCIIColor,
	60:  defaultPrintableASCIIColor,
	61:  defaultPrintableASCIIColor,
	62:  defaultPrintableASCIIColor,
	63:  defaultPrintableASCIIColor,
	64:  defaultPrintableASCIIColor,
	65:  defaultPrintableASCIIUpperAlphaColor, // A
	66:  defaultPrintableASCIIUpperAlphaColor,
	67:  defaultPrintableASCIIUpperAlphaColor,
	68:  defaultPrintableASCIIUpperAlphaColor,
	69:  defaultPrintableASCIIUpperAlphaColor,
	70:  defaultPrintableASCIIUpperAlphaColor,
	71:  defaultPrintableASCIIUpperAlphaColor,
	72:  defaultPrintableASCIIUpperAlphaColor,
	73:  defaultPrintableASCIIUpperAlphaColor,
	74:  defaultPrintableASCIIUpperAlphaColor,
	75:  defaultPrintableASCIIUpperAlphaColor,
	76:  defaultPrintableASCIIUpperAlphaColor,
	77:  defaultPrintableASCIIUpperAlphaColor,
	78:  defaultPrintableASCIIUpperAlphaColor,
	79:  defaultPrintableASCIIUpperAlphaColor,
	80:  defaultPrintableASCIIUpperAlphaColor,
	81:  defaultPrintableASCIIUpperAlphaColor,
	82:  defaultPrintableASCIIUpperAlphaColor,
	83:  defaultPrintableASCIIUpperAlphaColor,
	84:  defaultPrintableASCIIUpperAlphaColor,
	85:  defaultPrintableASCIIUpperAlphaColor,
	86:  defaultPrintableASCIIUpperAlphaColor,
	87:  defaultPrintableASCIIUpperAlphaColor,
	88:  defaultPrintableASCIIUpperAlphaColor,
	89:  defaultPrintableASCIIUpperAlphaColor,
	90:  defaultPrintableASCIIUpperAlphaColor, // Z
	91:  defaultPrintableASCIIColor,
	92:  defaultPrintableASCIIColor,
	93:  defaultPrintableASCIIColor,
	94:  defaultPrintableASCIIColor,
	95:  defaultPrintableASCIIColor,
	96:  defaultPrintableASCIIColor,
	97:  defaultPrintableASCIILowerAlphaColor, // a
	98:  defaultPrintableASCIILowerAlphaColor,
	99:  defaultPrintableASCIILowerAlphaColor,
	100: defaultPrintableASCIILowerAlphaColor,
	101: defaultPrintableASCIILowerAlphaColor,
	102: defaultPrintableASCIILowerAlphaColor,
	103: defaultPrintableASCIILowerAlphaColor,
	104: defaultPrintableASCIILowerAlphaColor,
	105: defaultPrintableASCIILowerAlphaColor,
	106: defaultPrintableASCIILowerAlphaColor,
	107: defaultPrintableASCIILowerAlphaColor,
	108: defaultPrintableASCIILowerAlphaColor,
	109: defaultPrintableASCIILowerAlphaColor,
	110: defaultPrintableASCIILowerAlphaColor,
	111: defaultPrintableASCIILowerAlphaColor,
	112: defaultPrintableASCIILowerAlphaColor,
	113: defaultPrintableASCIILowerAlphaColor,
	114: defaultPrintableASCIILowerAlphaColor,
	115: defaultPrintableASCIILowerAlphaColor,
	116: defaultPrintableASCIILowerAlphaColor,
	117: defaultPrintableASCIILowerAlphaColor,
	118: defaultPrintableASCIILowerAlphaColor,
	119: defaultPrintableASCIILowerAlphaColor,
	120: defaultPrintableASCIILowerAlphaColor,
	121: defaultPrintableASCIILowerAlphaColor,
	122: defaultPrintableASCIILowerAlphaColor, // z
	123: defaultPrintableASCIIColor,
	124: defaultPrintableASCIIColor,
	125: defaultPrintableASCIIColor,
	126: defaultPrintableASCIIColor,
	127: defaultUpperBytesColor,
	128: defaultUpperBytesColor,
	129: defaultUpperBytesColor,
	130: defaultUpperBytesColor,
	131: defaultUpperBytesColor,
	132: defaultUpperBytesColor,
	133: defaultUpperBytesColor,
	134: defaultUpperBytesColor,
	135: defaultUpperBytesColor,
	136: defaultUpperBytesColor,
	137: defaultUpperBytesColor,
	138: defaultUpperBytesColor,
	139: defaultUpperBytesColor,
	140: defaultUpperBytesColor,
	141: defaultUpperBytesColor,
	142: defaultUpperBytesColor,
	143: defaultUpperBytesColor,
	144: defaultUpperBytesColor,
	145: defaultUpperBytesColor,
	146: defaultUpperBytesColor,
	147: defaultUpperBytesColor,
	148: defaultUpperBytesColor,
	149: defaultUpperBytesColor,
	150: defaultUpperBytesColor,
	151: defaultUpperBytesColor,
	152: defaultUpperBytesColor,
	153: defaultUpperBytesColor,
	154: defaultUpperBytesColor,
	155: defaultUpperBytesColor,
	156: defaultUpperBytesColor,
	157: defaultUpperBytesColor,
	158: defaultUpperBytesColor,
	159: defaultUpperBytesColor,
	160: defaultUpperBytesColor,
	161: defaultUpperBytesColor,
	162: defaultUpperBytesColor,
	163: defaultUpperBytesColor,
	164: defaultUpperBytesColor,
	165: defaultUpperBytesColor,
	166: defaultUpperBytesColor,
	167: defaultUpperBytesColor,
	168: defaultUpperBytesColor,
	169: defaultUpperBytesColor,
	170: defaultUpperBytesColor,
	171: defaultUpperBytesColor,
	172: defaultUpperBytesColor,
	173: defaultUpperBytesColor,
	174: defaultUpperBytesColor,
	175: defaultUpperBytesColor,
	176: defaultUpperBytesColor,
	177: defaultUpperBytesColor,
	178: defaultUpperBytesColor,
	179: defaultUpperBytesColor,
	180: defaultUpperBytesColor,
	181: defaultUpperBytesColor,
	182: defaultUpperBytesColor,
	183: defaultUpperBytesColor,
	184: defaultUpperBytesColor,
	185: defaultUpperBytesColor,
	186: defaultUpperBytesColor,
	187: defaultUpperBytesColor,
	188: defaultUpperBytesColor,
	189: defaultUpperBytesColor,
	190: defaultUpperBytesColor,
	191: defaultUpperBytesColor,
	192: defaultUpperBytesColor,
	193: defaultUpperBytesColor,
	194: defaultUpperBytesColor,
	195: defaultUpperBytesColor,
	196: defaultUpperBytesColor,
	197: defaultUpperBytesColor,
	198: defaultUpperBytesColor,
	199: defaultUpperBytesColor,
	200: defaultUpperBytesColor,
	201: defaultUpperBytesColor,
	202: defaultUpperBytesColor,
	203: defaultUpperBytesColor,
	204: defaultUpperBytesColor,
	205: defaultUpperBytesColor,
	206: defaultUpperBytesColor,
	207: defaultUpperBytesColor,
	208: defaultUpperBytesColor,
	209: defaultUpperBytesColor,
	210: defaultUpperBytesColor,
	211: defaultUpperBytesColor,
	212: defaultUpperBytesColor,
	213: defaultUpperBytesColor,
	214: defaultUpperBytesColor,
	215: defaultUpperBytesColor,
	216: defaultUpperBytesColor,
	217: defaultUpperBytesColor,
	218: defaultUpperBytesColor,
	219: defaultUpperBytesColor,
	220: defaultUpperBytesColor,
	221: defaultUpperBytesColor,
	222: defaultUpperBytesColor,
	223: defaultUpperBytesColor,
	224: defaultUpperBytesColor,
	225: defaultUpperBytesColor,
	226: defaultUpperBytesColor,
	227: defaultUpperBytesColor,
	228: defaultUpperBytesColor,
	229: defaultUpperBytesColor,
	230: defaultUpperBytesColor,
	231: defaultUpperBytesColor,
	232: defaultUpperBytesColor,
	233: defaultUpperBytesColor,
	234: defaultUpperBytesColor,
	235: defaultUpperBytesColor,
	236: defaultUpperBytesColor,
	237: defaultUpperBytesColor,
	238: defaultUpperBytesColor,
	239: defaultUpperBytesColor,
	240: defaultUpperBytesColor,
	241: defaultUpperBytesColor,
	242: defaultUpperBytesColor,
	243: defaultUpperBytesColor,
	244: defaultUpperBytesColor,
	245: defaultUpperBytesColor,
	246: defaultUpperBytesColor,
	247: defaultUpperBytesColor,
	248: defaultUpperBytesColor,
	249: defaultUpperBytesColor,
	250: defaultUpperBytesColor,
	251: defaultUpperBytesColor,
	252: defaultUpperBytesColor,
	253: defaultUpperBytesColor,
	254: defaultUpperBytesColor,
	255: defaultNULLEOFColor, // 255, 0xFF
}
